	Name	DATRANGE		;(.COM) Paul Emmons Apr. 1, 2000
Code	segment
	assume	CS: Code, DS: Code, ES: Code, SS: Code
	org	100h
Datrang	proc	near
	xor	AX,AX
	mov	SI,80h			;^args
	lodsb
	mov	DI,SI
	add	DI,AX			;DI ^ past args
	mov	byte ptr [DI],'$'	;sentinel
	call	Asc2int
	mov	DI,AX			;1st mmdd
	call	Asc2int
	mov	BX,AX			;2nd mmdd
	mov	AH,2Ah			;to get system date
	int	21h
	mov	AX,100
	mul	DH			;AX <-- month * 100
	xor	DH,DH
	add	AX,DX			;AX += day
	cmp	DI,BX
	ja	dowrap
	cmp	AX,DI
	jb	ret0
	cmp	AX,BX
	ja	ret0
ret1:	mov	AL,1
fini:	mov	AH,4Ch
	int	21h
ret0:	xor	AX,AX
	jmp	short	fini
dowrap:	cmp	AX,DI			;date range wraps around to new year
	jae	ret1			;sys date in range if >= date 1
	cmp	AX,BX			;or <= date 2
	jbe	ret1
	jmp	short	ret0
;----------------------------------------------------------
Asc2int	label	near
	push	DX
	xor	AX,AX
	mov	DX,AX
a2i1:	lodsb
	cmp	AL,' '
	jbe	a2i1
a2ilp:	sub	AL,'0'
	jl	a2idon
	cmp	AL,9
	ja	a2idon
	shl	DX,1
	add	AX,DX
	shl	DX,1
	shl	DX,1
	add	DX,AX
	lodsb
	jmp	short	a2ilp
a2idon:	dec	SI
	mov	AX,DX
	pop	DX
	cmp	AX,101		;check that argument is in range
	jb	shohelp		;show help and quit if invalid
	cmp	AX,1231
	ja	shohelp
	ret
shohelp:mov	DX,offset Help
	mov	AH,9		;'$'-terminated string --> stdout
	int	21h
	pop	DX		;local return address
	jmp	short	ret0
Help	db	'Usage: DATRANG	mmdd mmdd',13,10
	db	'If system date >=1st arg and <=2nd arg, returns 1, else 0'
	db	13,10,'--Paul Emmons$' 
Datrang	endp
Code	ends
	end Datrang
;=============================================================================
